{ Disk services for Windows-likely ini.file
  CopyRight (C) V Kulimov, 1994.

  INIFILE.TPU - ᪮ 䥩  ini.file.
  ⠥  ᪠ ini.file.   㧨 ini-  
  ६ Profile   楤 LoadProfile   
  㭪樨 GetProfile(FileName) 㧨 ini-  ᢮ 㪠⥫
   PIniFile - ⠪ ࠧ   ࠭   ࠧ
  ᪮쪮 ini.䠩, ⮫쪮 । 맮  ࢨ 㭪権 
  㪠⥫,    ࠡ,  Profile,  ⥬ ⠭
    Profile (  ᨨ 1.1  楤  ࠡ  㪠⥫
   PIniFile -    ᫮ Private - ਬ
  GetPrivateProfileString(Appl, Key, Default: String; IniData: PIniFile): String
  頥 ப  ᥪ樨 Appl  Key  .ini-䠩, 㦥
   㪠⥫ IniData)

   㬠,   ਤ  뢠 ⮤ ' PIniFile.
  ⮡  ini.file   ᯮ SaveProfile -  㤠
  㣮  ᨬ 㤠 ⠭ ini.file  KillProfile c ࠬ஬
  psSave (. psXXXX - pROFILE sAVE ⠭  䠩 INISERV.PAS) ࠭
  .ini-file ⠬ ,   ⠫.  ᯥ .ini-file 맢
  SaveProfile('LPT1').
   ' TAppObj  ࠪ -   ᮧ App-ᥪ樨 
  ⥭  䠩, 㣮  ᮧ   ணࠬ.
  ⠫ ⮭ see below.
    ࠪ  TIniFile -  ⮣  ᠬ.
   砭:
     ஡ ন   [App-Section], ⠪  
      key = value
     ᫥ value  ⠢ ਨ    ࠭
        value, ..
      key = value ; comment
      ᯮ짮 semicolon `;'   value ⠢   `;;'
     semicolon  [App-section]  key =  ন
     ਨ   稭  ; -  ᮡ ਭ樯 
      .ini-䠩:
       ப  ࢮ [App-section] -  ਩,
      ࠭ ⤥쭮 - ᫨  ,  ⠢
      㪠⥫  String   HeadNotes ' TIniFile.
       o [App-section]  ᫥饩 ਭ .
      ਨ ⫨  key = value ⮫쪮 ⢨
       =.
}

Unit
  IniFile;

Interface

Uses
  Objects, Dos, Tools;

Type
  PKeyObj = ^TKeyObj;
  TKeyObj = Object(TObject)
    Key, Value: PString;
  {   Value ᮤন 祭  ਩ (᫨ ) - ਬ
      Key1 = Value1 ; Notes
    ..   Key  ,    "ࠢ",
      Value   ᫥. ᫨   "=",  ⠥
      ப - ਩,   ࠭   Key,
     Value   砥 ࠢ NIL. 祬 ࠧ筮 
    祣 稭 ப -      `;' }
    Constructor Init(var P: PString);
    Destructor Done; Virtual;
  End;

  PAppObj = ^TAppObj;
  TAppObj = Object(TObject)
     AppName: PString; {  ᥪ樨   `[' , `]' }
     Keys: PCollection; { ⥫    PKeyObj }
     Constructor Init(T: PTextStream);
     Constructor InnerInit(Appl, Key, Eval: String);
     Destructor Done; Virtual;
  End;

  PIniFile = ^TIniFile;
  TIniFile = Object(TObject)
    IniData: PCollection; { ⥫    PAppObj }
    Constructor Init(FName: PathStr);
    Constructor TinyInit(PName: PathStr; C: PNoSortedStringCollection);
    Destructor Done; Virtual;
    Destructor TinyDone; Virtual;
    Procedure WriteIni(PName: PathStr);
  Private
    ProfileName: PathStr;
    HeadNotes: PNoSortedStringCollection;
  End;

Implementation

Uses
  Arc;
{  TKeyObject Methods  }

Constructor TKeyObj.Init(Var P: PString);
Var
  S,K: String;
Begin
  Key := Nil;
  Value := Nil;
  S := P^;
  if Pos('=', S) = 0 then
     Key := P
  else
  Begin
    K := Copy(S, 1, Pos('=', S) - 1);
    Key := NewStr(K);
    Delete(S, 1 , Pos('=', S));
    if Pos(#13#10, S) <> Byte(S[0]) - 1 then
       S := S + #13#10;
    Value := NewStr(S);
    DisposeStr(P);
  End;
End;

Destructor TKeyObj.Done;
Begin
  if Key <> Nil then DisposeStr(Key);
  if Value <> Nil then DisposeStr(Value);
  Inherited Done;
End;

{  TAppObj  }
Constructor TAppObj.Init(T: PTextStream);
{ 뢠  㧪  䠩 樨஢  
   PTextStream }
Var
  V: PKeyObj;
  P: PString;
  A: Text;
  LastAction: Boolean;
Begin
  Inherited Init;
  LastAction := False;
  Keys  := Nil;
  P := T^.ReadStr;
  if P = Nil then
     Fail;
  While P^[1] <> '[' do
    P := T^.ReadStr;

  AppName := P;

  P := T^.ReadStr;

  While P^[1] <> '[' do
  Begin
    if Not Assigned(Keys) then
        New(Keys, Init(5, 1));
    Keys^.Insert(New(PKeyObj, Init(P)));
    P := T^.ReadStr;
    if P = Nil then
    Begin
      LastAction := True;
      Break;
    End;
  End;

  if Not LastAction then
     T^.Seek(T^.GetPos - Length(P^) - 2);
End;

Constructor TAppObj.InnerInit(Appl, Key, Eval: String);
{ 뢠  ᮧ  ᥪ樨 }
Var
  P: PString;
Begin
  AppName := NewStr(#13#10'['+Appl+']'#13#10);
  New(Keys, Init(1, 1));
  P := NewStr(Key + '=' + Eval + #13#10);
  Keys^.Insert(New(PKeyObj, Init(P)));
End;

Destructor TAppObj.Done;
Begin
  DisposeStr(AppName);
  if Assigned(Keys) then
    Dispose(Keys, Done);
  Inherited Done;
End;


{  TIniFile Object Methods  }
Constructor TIniFile.Init(FName: PathStr);
Var
  T: PTextStream;
  A: PAppObj;
  P: PString;
Begin
  ProfileName := FName;
  T := New(PTextStream, Init(FName, stOpenRead, 2048));
  if T^.Status <> stOk then
  Begin
     Dispose(T, Done);
     Fail;
  End;

  New(HeadNotes, Init(5, 1));
  Repeat
    P := T^.ReadStr;
    if (P <> Nil) and (P^[1] <> '[') then HeadNotes^.Insert(P)
    else
      Break;
  Until False;
  if HeadNotes^.Count = 0 then
  Begin
     Dispose(HeadNotes, Done);
     HeadNotes := Nil;
  End;

  T^.Seek(0);

  IniData := New(PCollection, Init(3, 1));
  Repeat
    A := New(PAppObj, Init(T));
    if Assigned(A) then
       IniData^.Insert(A)
    else
       Break;
  Until False;
End;

Constructor TIniFile.TinyInit(PName: PathStr; C: PNoSortedStringCollection);
{   '   易    .ini-䠩  ᪥.
  뢠  ணࠬ.     ᯮ SaveProfile }
Begin
  ProfileName := PName;
  HeadNotes := C;
  IniData := New(PCollection, Init(3, 1));
End;

Destructor TIniFile.TinyDone;
{ ࠥ '  ,   ࠭   ᪥.
   ࠭ ᯮ Done }
Var
  i: Word;
Begin
  if HeadNotes <> Nil then
     Dispose(HeadNotes, Done);
  Dispose(IniData, Done);
  Inherited Done;
End;

Destructor TIniFile.Done;
Begin
  WriteIni(ProfileName);
  TinyDone;
End;

Procedure TIniFile.WriteIni(PName: PathStr);
{  .ini-䠩   }
Var
  T: PLogFile;
  E: Boolean;

  Procedure PrintApp(Item: PAppObj); Far;
    Procedure PrintKey(Item: PKeyObj); Far;
    Begin
      if Item^.Value =  Nil then
      Begin
        if Item^.Key <> Nil then
           T^.WriteTo(Item^.Key^)
      End
      else
         T^.WriteTo(DelSpace(Item^.Key^) + '=' + DelSpace(Item^.Value^));
    End;
  Begin
    if Item^.AppName <> Nil then
       T^.WriteTo(Item^.AppName^);
    if Item^.Keys <> Nil then
       Item^.Keys^.ForEach(@PrintKey);
  End;

  Procedure PrintHead(Item : PString); Far;
  Begin
    T^.WriteTo(Item^);
  End;

Begin
  E := Not Exist(PName);

  T := New(PLogFile, Init(PName, stCreate, 2048));
  if T^.Status <> stOk then
  Begin
    Dispose(T, Done);
    Exit
  End;
  if Assigned(HeadNotes) then HeadNotes^.ForEach(@PrintHead);
  if Assigned(IniData) then IniData^.ForEach(@PrintApp);
  if E then
    T^.WriteTo(#13#10';'#13#10'; End of '+UpperCase(PName)+#13#10';'#13#10);
  Dispose(T, Done);
End;

End.