{$V-}

Unit
   TimeOut;

Interface

Uses
   App, Drivers, GadGets, Objects, Views;

{$IFDEF DPMI}
{$DEFINE NoSaveScreen}
{$ENDIF}

Const
  HeapSize: LongInt = 64 * (1024 div 16);  { 64k  }

Type
{
    ⠫ ॠ  ,   NORTON'e.
  C.  APP.PAS - ⠬   TProgram.GetEvent ⨫
  ਢ  - த ࠡ⠥.
  襭 㡠 맮 SetTimeDelay(-1)

  ᯮ ⮬  TGadGetsApp  ᢮ ணࠬ -
       ࠧ ⠢ Heap & Clock, ࠡ稪 Help'a,
  맮 , ࠭ ࠭,  DeskTop,  Idle
    ॡ, ⮫쪮  ணࠬ.
   ᮢ⮢     ꥪ 楤 HandleEvent
   ࠡ稪 cmAbout, cmSelColor, etc. 쪮 
     ⮬  ꥪ ࠪ ⮤  
  ,  㦭 ⮬ ४  ᢮ ⮬.

  !!!!
    Init'e ᢮ ⮬ । ६ MaxHeapSize -
   ⥬ 맮 Init ।.

    楤ઠ ExitProc - ᮮ饭
   Runtime error XXXX at XXXX:XXXX   祫᪮.

  ७ ᪮७ ᨫ -
     "" -    ࠢ 孨 㣮,   Nortion'e,
    c  - ६ ⨥ Alt+Ctrl,
  ⮡ ࠭     ""   孨 㣮.
}

  SaveScreen = Array[1..4000] of Byte;

  PGadGetsApp = ^TGadGetsApp;
  TGadGetsApp = Object(TApplication)
     Heap: PHeapView;
     Clock: PClockView;
     Sec: Byte;
     Constructor Init;
     Destructor Done; Virtual;
     Procedure Idle; Virtual;
     Procedure GetEvent(Var Event: TEvent); Virtual;
     Procedure SetTimeDelay(D: Integer);
     Procedure HandleEvent(var Event: TEvent); Virtual;
     Procedure InitDeskTop; Virtual;
     Procedure InitScreen; Virtual;
     Function  GetPalette: PPalette; virtual;
  Private
     RunTimeOut: Boolean;
     TimeDelay : Integer;
     Procedure TimeHide;
  End;

  { 騥 2 ' -  ᮧ ᢮ 䮭 DeskTop'a -
      室  ⮣ 室  .ini-䠩 
    [Files]
    ...
    Desk Top = ... ; ᫨  ப  䠩  ,
                   ;  DeskTop ⠭.
    ...

    [Desk Top]
    ZipFile = On ;  娢஢ 䠩 ࠭,
    ;              ᫨ 祭,  ணࠬ 稢 
    ;               BACKGRND.TMP,   .
    ;               ⮡   直 ਤન  
    ;              﫨 CopyRight.
    TextColor = ... ;  ᨬ, default = Yellow
    TextBackGround = ... ;  䮭, default = Blue
    ;    Pascal'e:
      Black, Blue, Green, etc... 
      0    , 1   , 2    ,
    }

  PMyBackground = ^TMyBackground;
  TMyBackground = object(TBackground)
    Procedure Draw; virtual;
    Function LoadDeskTop: Boolean;
  Private
    Aga       : Array[1..23] of String[80];
    ExistFile: Boolean;
  end;

  PMyDesktop = ^TMyDesktop;
  TMyDesktop = object(TDesktop)
    procedure InitBackGround; virtual;
  end;

Var
  OldExitProc: Pointer;
  sSave      : SaveScreen;

Implementation

Uses
   Memory, Crt, Dos, Arc, IniServ, Calc, Dialogs, HelpFile,
   Validate, StdConst, Tools, MsgBox, Zip;

Const
  ReRead: Boolean = True;

Var
  OldScr     : SaveScreen Absolute $B800:0000;
  Y          : Byte;

{  TMyBackGround Object  }

Function TMyBackGround.LoadDeskTop: Boolean;
Var
  T: System.Text;
  j: Byte;
begin
  LoadDeskTop := False;
  Assign(T, 'BACKGRND.TMP');
  {$i-}
  Reset(T);
  if IOResult <> 0 then
    Exit;
  j := 1;
  While Not Eof(T) do
  Begin
    ReadLn(T, Aga[j]);
    While Length(Aga[j]) < 80 do
      Aga[j] := Aga[j] + ' ';
    Inc(j);
    if j > 23 then Break;
  End;
  Close(T);
  {$i-}
  Erase(T);
  While j < 24 do
  Begin
    Aga[j] := Space(80);
    Inc(j);
  End;
  LoadDeskTop := True;
  ReRead := False;
End;

Procedure TMyBackGround.Draw;
  Function GetColorBackGround: Byte;
  Const
    Colors: Array[0..15] of String[12] =
    ('BLACK', 'BLUE', 'GREEN', 'CYAN', 'RED', 'MAGENTA', 'BROWN',
     'LIGHTGRAY', 'DARKGRAY', 'LIGHTBLUE', 'LIGHTGREEN', 'LIGHTCYAN',
     'LIGHTRED', 'LIGHTMAGENTA', 'YELLOW', 'WHITE');
  Var
    S: String;
    C: Integer;
    i,j: Byte;
    FindColor: Boolean;
  Begin
    S := GetProfileString('Desk Top', 'TextColor', 'Yellow');
    Val(S, i, C);
    if C <> 0 then
    Begin
      S := UpperCase(S);
      FindColor := False;
      For i := 0 to 15 do
      Begin
        FindColor := S = Colors[i];
        if FindColor then
           Break;
      End;
      if Not FindColor then
         i := Yellow;
    End;
    S := GetProfileString('Desk Top', 'TextBackGround', 'Blue');
    Val(S, j, C);
    if C <> 0 then
    Begin
      S := UpperCase(S);
      FindColor := False;
      For j := 0 to 15 do
      Begin
        FindColor := S = Colors[j];
        if FindColor then
           Break;
      End;
      if Not FindColor then
         i := Blue;
    End;
    GetColorBackGround := j * 16 + i;
  End;
var
  DrawBuffer: TDrawBuffer;
  j: Byte;
  A: Byte;
begin
  if ReRead then
     ExistFile := LoadDeskTop;
  if ExistFile then
  Begin
    A := GetColorBackGround;
    For j := 0 to 22 do
    Begin
      MoveStr(DrawBuffer, Aga[j+1], A);
      WriteLine(0, j, Size.X, 1, DrawBuffer);
    End;
  End
  else
    Inherited Draw;
End;

{  TMyDeskTop Object  }

procedure TMyDesktop.InitBackGround;
var
  R: TRect;
  X: Boolean;
  xMode: TCopyFile;
  xName: PathStr;
begin
  GetExtent(R);
  xName := GetProfileString('Files', 'Desk Top', '');
  if (xName = '') or (Not Exist(xName)) then
    Inherited InitBackGround
  else
  Begin
    if GetProfileBoolean('Desk Top', 'ZipFile', True) then
       xMode := cfUnZip
    else
       xMode := cfNoZip;
    X := ZIP.CopyFile(xName, 'BACKGRND.TMP', xMode) = cfOk;
    if X then
       BackGround := New(PMyBackground, Init(R, ' '))
    else
       Inherited InitBackGround;
  End;
end;

{  TGadGetsApp Object Methods  }

Constructor TGadGetsApp.Init;
Var
  R: TRect;
  E: TEvent;
  C: Integer;
Begin
{ MaxHeapSize := HeapSize;}
  Inherited Init;

  GetExtent(R);
  R.A.X := R.B.X - 9;
  R.B.Y := R.A.Y + 1;
  Clock := New(PClockView, Init(R));
  Insert(Clock);

  GetExtent(R);
{  Dec(R.B.X); }
  R.A.X := R.B.X - 8;
  R.A.Y := R.B.Y - 1;
  Heap := New(PHeapView, Init(R));
  Insert(Heap);

  if Assigned(Profile) then
  Begin
    C := GetProfileInt('Screen Blank', 'Delay', 7);
    Case  C of
       1: SetTimeDelay(60*60);
       2: SetTimeDelay(45*60);
       3: SetTimeDelay(30*60);
       4: SetTimeDelay(15*60);
       5: SetTimeDelay(10*60);
       6: SetTimeDelay(5*60);
       7: SetTimeDelay(1*60);
      -1: SetTimeDelay(C);
    else
       SetTimeDelay(GetProfileInt('Screen Blank', 'Second', 15));
    End;
  End
  else
  Begin
    TimeDelay := 60;
    TimeCount := 0;
  End;
  Sec := 61;
  RunTimeOut := True;
End;

Procedure TGadGetsApp.InitScreen;
begin
  asm
    MOV  AX,$1003
    XOR  BL,BL
    INT  $10
  end;
  Inherited InitScreen;
end;

Procedure TGadGetsApp.InitDesktop;
Var
  R: TRect;
begin
  GetExtent(R);
  R.Grow(0, -1);
  DeskTop := New(PMyDesktop, Init(R));
end;

Procedure TGadGetsApp.SetTimeDelay(D: Integer);
{ D = -1 ⪫砥 ,
   D - প । 襭 ࠭ }
{ 뢠  Init'e ⮬  TGadGetsApp   ६
  襭 ࠭.  㬮砭  -  .
}
Begin
  if d = -1 then RunTimeOut := False;
  TimeDelay := D;
End;

Procedure TGadGetsApp.TimeHide;
{   ୮  
  直 ⥫  ࠭ }
Const
  StarsCount = 20; { ᫮  祢. }
  Delaying = 150;
  Chars: Array[1..4] of Char = ('*', '', '', ' ');
Var
  i,j: Byte;
  Star: Array[1..StarsCount] of TPoint;
  Event: TEvent;
  Out: Boolean;

Function GetEv: Boolean;
Begin
  if Out then Exit;
  GetEv := False;
  GetKeyEvent(Event);
  if Event.What <> evNothing then
  Begin
    GetEv := True;
    Out := True;
  End
  else
  Begin
    GetMouseEvent(Event);
    if Event.What <> evNothing then
    Begin
      GetEv := True;
      Out := True;
    End;
  End;
End;

Begin
  RunTimeOut := False;
  DoneSysError;
{  DoneEvents; }
  HideMouse;
  DoneVideo;
  DoneDosMem;
  Randomize;
  TextColor(Cyan);
  TextBackGround(Black);

  Event.What := evNothing;
  CursorOff;
  Out := False;
  For i := 1 to StarsCount do
  Begin
    Star[i].X := 1;
    Star[i].Y := 1;
    Star[i].X := Random(79) + 1;
    Star[i].Y := Random(24) + 1;
    GotoXY(Star[i].X, Star[i].Y);
    WriteLn('');
    Delay(100);
    if GetEv then Break;
  End;
  if Not Out then
  Repeat
    For i := 1 to StarsCount do
    Begin
      TextColor(White);
      For j := 1 to 4 do
      Begin
        GotoXY(Star[i].X, Star[i].Y);
        Write(Chars[j]);
        if GetEv then Break;
        Delay(Delaying+50);
      End;
      TextColor(Cyan);
      Star[i].X := Random(79) + 1;
      Star[i].Y := Random(24) + 1;
      GotoXY(Star[i].X, Star[i].Y);
      WriteLn('');
      if GetEv then Break;
      Delay(Delaying);
    End;
  Until Out;

  CursorOn;
  InitDosMem;
  InitVideo;
{  InitEvents; }
  ShowMouse;
  InitSysError;
  Redraw;
  RunTimeOut := True;
  TimeCount := 0;
End;

Procedure TGadGetsApp.Idle;
Var
  h, m, s, hund : Word;
Begin
  Inherited Idle;
  GetTime(h,m,s,hund);
  if RunTimeOut and (S <> Sec) then
  Begin
    Sec := S;
    Inc(TimeCount);
  End;
  if TimeDelay <= TimeCount then
     TimeHide;
  Heap^.UpDate;
  Clock^.UpDate;
end;

Procedure TGadGetsApp.GetEvent;
var
  W: PHelpWindow;
  HelpFile: PHelpFile;
  HelpStrm: PDosStream;
  Pa: LongInt;
  HF, StdHF, A, B, C: PathStr;
  MousePos: TPoint;
  ShiftState: Byte absolute $40:$17;
const
  HelpInUse: Boolean = False;
begin
  if Event.What <> evNothing then
    TimeCount := 0;
  if Event.What = evMouseMove then
  Begin
    MakeLocal(Event.Where, MousePos);
    RunTimeOut := Not ((MousePos.X = 79) and (MousePos.Y = 24));
    if (MousePos.X = 79) and (MousePos.Y = 0) then
       TimeCount := TimeDelay;
  End;
  if ShiftState and (kbAltShift or kbCtrlShift) =
     kbAltShift + kbCtrlShift then
     TimeCount := TimeDelay;

  inherited GetEvent(Event);
  { This part:
         Copyright (C) Serge Latkin & Co, 1992-94.
         Excepting call GetProfileString.  }
  if Event.What <> evCommand then Exit;
  { Help }
  if (Event.Command = cmHelp) AND NOT HelpInUse then
  begin
    StdHF := ParamStr(0);
    StdHF := FExpand(StdHF);
    FSplit(StdHF, A, B, C);
    StdHF := A + B + '.HLP';

    HF := GetProfileString('Files', 'Help file', StdHF);
    HelpStrm := New(PDosStream, Init( HF, stOpenRead));
    HelpFile := New(PHelpFile, Init(HelpStrm));
    if HelpStrm^.Status <> stOk then
    begin
      MessageBox(^C'    䠩 .', Nil, mfError + mfOkButton);
      Disposes(PObject(HelpFile));
    end
    else
    begin
      HelpInUse := True;
      W := New(PHelpWindow,Init(Helpfile, PushCtx(GetHelpCtx)));
      W^.HelpCtx := hcHHelpWindows;
      if ValidView(W) <> nil then
      begin
	ExecView(W);
	Disposes(PObject(W));
      end;
      HelpInUse := False;
      ClearEvent(Event);
    end;
  end
  { Alt Help }
  else if (Event.Command = cmAltHelp) AND NOT HelpInUse then
  begin
    StdHF := ParamStr(0);
    StdHF := FExpand(StdHF);
    FSplit(StdHF, A, B, C);
    StdHF := A + B + '.HLP';

    HF := GetProfileString('Files', 'Help file', StdHF);
    HelpStrm := New(PDosStream, Init( HF, stOpenRead));
    HelpFile := New(PHelpFile, Init(HelpStrm));
    if HelpStrm^.Status <> stOk then
    begin
      MessageBox(^C'    䠩 .', Nil, mfError + mfOkButton);
      Disposes(PObject(HelpFile));
    end
    else
    begin
      HelpInUse := True;
      W := New(PHelpWindow,Init(Helpfile, PopCtx));
      W^.HelpCtx := hcHHelpWindows;
      if ValidView(W) <> nil then
      begin
	ExecView(W);
	Disposes(PObject(W));
      end;
      HelpInUse := False;
      ClearEvent(Event);
    end
  end
end;

function TGadGetsApp.GetPalette: PPalette;
const
  CNewColor = CColor + CHelpColor;
  CNewBlackWhite = CBlackWhite + CHelpBlackWhite;
  CNewMonochrome = CMonochrome + CHelpMonochrome;
  P: array[apColor..apMonochrome] of string[Length(CNewColor)] =
    (CNewColor, CNewBlackWhite, CNewMonochrome);
begin
  GetPalette := PPalette(@P[AppPalette]);
end;

Procedure TGadGetsApp.HandleEvent;
  Procedure Calculator;
  Var
    C: PCalculator;
    P: TPoint;
  Begin
    P.X := GetProfileInt('Calculator', 'X', 15);
    P.Y := GetProfileInt('Calculator', 'Y', 3);
    C := New(PCalculator, Init(P));
    InsertWindow(C);
  End;

  Procedure SetDelay;
  Type
    TDelayRec = Record
      A: Integer;
      S: String;
    End;
  Var
     R: TRect;
     D: PDialog;
     P: PRadioButtons;
     L: PInputLine;
     C,O: Integer;
     W: TDelayRec;
   Begin
     W.A := GetProfileInt('Screen Blank', 'Delay', 7);
     Case W.A of
       0: W.A := 8;
      -1: W.A := 0;
     End;
     W.S := GetProfileString('Screen Blank', 'Second', '15');

     R.Assign(0, 0, 44, 16);
     D := New(PDialog, Init(R, 'প 襭 ࠭'));
     With D^ do
     Begin
       Options := Options or ofCentered;

       HelpCtx := hcDelayDialog;

       R.Assign(3, 3, 23, 12);
       P := New(PRadioButtons, Init(R,
              NewSItem('⪫祭',
              NewSItem('1 ',
              NewSItem('45 ',
              NewSItem('30 ',
              NewSItem('15 ',
              NewSItem('10 ',
              NewSItem('5 ',
              NewSItem('1 ',
              NewSItem('㣮',
	      Nil)))))))))
	    ));
       Insert(P);
       R.Assign(1, 2, 30, 3);
       Insert(New(PLabel, Init(R, '६ 襭 ࠭', P)));

       R.Assign(22, 13, 30, 14);
       L := New(PInputLine, Init(R, 6));
       L^.SetValidator(New(PFilterValidator, Init(['0'..'9'])));
       Insert(L);

       R.Assign(1, 13, 21, 14);
       Insert(New(PLabel, Init(R, 'প  ᥪ㭤', L)));

       R.Assign(25, 3, 42, 5);
       Insert(New(PButton, Init(R, 'OK', cmOk, bfDefault)));

       R.Move(0, 2);
       Insert(New(PButton, Init(R, 'O⬥', cmCancel, bfNormal)));

       R.Move(0, 2);
       Insert(New(PButton, Init(R, '', cmHelp, bfNormal)));

       SelectNext(False);
     End;
     if ExecuteDialog(D, @W) = cmOk then
     Begin
       Case W.A of
         0: Begin
              SetTimeDelay(-1);
              W.A := -1;
            End;
         1: SetTimeDelay(60*60);
         2: SetTimeDelay(45*60);
         3: SetTimeDelay(30*60);
         4: SetTimeDelay(15*60);
         5: SetTimeDelay(10*60);
         6: SetTimeDelay(5*60);
         7: SetTimeDelay(1*60);
       else
         Val(W.S, O, C);
         if C = 0 then
         Begin
           SetTimeDelay(O);
           W.A := 0;
         End;
       End;
       SetProfileString('Screen Blank', 'Second', W.S);
       SetProfileInt('Screen Blank', 'Delay', W.A);
     End;
   End;

Begin
  Inherited HandleEvent(Event);
  if Event.What = evCommand then
  Case Event.Command of
    cmCalc: Calculator;
    cmDelay: SetDelay;
  End;
End;

Destructor TGadGetsApp.Done;
Begin
  KillProfile(psSave);
  Inherited Done;
  asm
     mov   ax,$03
     int   $10
  end;

{$IFNDEF NoSaveScreen}
  OldScr := sSave;
  GotoXY(1, Y);
{$ENDIF}
End;

{$IFNDEF AnotherExitProc}
Procedure NewExitProc; far;
var
  EA: Pointer;
begin
  ExitProc := OldExitProc;
  EA := ErrorAddr;
  if EA <> Nil then
  begin
     GotoXY(1,1);
     TextAttr := 15;
     ClrScr;
     writeln(#10#7' 訡  pp ', ParamStr(0),' ( ',ExitCode,').');
     writeln('  pp稪 ᫥⥫쭮  ⢨'#13#10,
             '   訡    p㦥  p .'#10);
     textattr := Yellow;
     writeln(' H    室...');
     ReadK;
  end
end;
{$ENDIF}

begin
{$IFNDEF AnotherExitProc}
  OldExitProc := ExitProc;
  ExitProc := @NewExitProc;
{$ENDIF}

{$IFNDEF NoSaveScreen}
  sSave := OldScr;
  Y := WhereY;
{$ENDIF}

End.
