{ The basic object for Windows Application -
  field MainWindow from TApllication can draw any BITMAP }

Unit
  WinMain;

Interface

Uses
  OWindows, WinTypes;

Type
  PBitMapWindow = ^TBitmapWindow;
  TBitMapWindow = object(TWindow)
    DT: HBitMap;
    Procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); Virtual;
    Procedure DrawBMP(DC: HDC; X, Y, BitMap: HBitMap);
  End;


Implementation

Uses
  WinProcs;


Procedure TBitMapWindow.DrawBMP(DC: HDC; X, Y, BitMap: HBitMap);
var
  MemDC: HDC;
  bm: TBitMap;
  MadeDC: Boolean;
begin
  if DC = 0 then
  begin
    DC := GetDC(HWindow);
    MadeDC := True;
  end
  else
    MadeDC := False;
  MemDC := CreateCompatibleDC(DC);
  SelectObject(MemDC, BitMap);
  GetObject(DT, SizeOf(bm), @bm);
  BitBlt(DC, X, Y, bm.bmWidth, bm.bmHeight, MemDC, 0, 0, SRCCopy);
  DeleteDC(MemDC);
  if MadeDC then ReleaseDC(HWindow, DC);
end;

Procedure TBitMapWindow.Paint;
Begin
  DrawBMP(PaintDC, 0, 0, DT);
End;


End.